#include <math.h>
#include <stdio.h>		//Librera de E/S
#include <stdlib.h>		//Librera estndar		
#include <string.h>		//Librera para manejar strings.
#include "variables.h"

void mensaje_de_error (void);
void cargarlistaaux (TablaHashT, unsigned int);
void crearlistarnd (TablaHashT, TablaHashT, int);
void escribir_archivo_gnu (int, char**);
unsigned long int crearclave (Elemento);
TablaHashT CrearTHash (int);
int InsertarHash (TablaHashT, Elemento, int, int, int &);
int BuscarHash (TablaHashT, Elemento, int, int, int &);
void DestruirTHash (TablaHashT, int);

int main (int argc, char **argv)
{ 
  FILE *DFIns;			//Archivo de datos de insercin
  FILE *DFBus;			//Archivo de datos de bsqueda
  int error = 0,       		//error = 0 si no hubo error; error = 1 si hubo error
      i,j,k,l,			//Contadores
      tipo_de_hash;		//Tipo de hash a ejecutar
  TablaHashT ListaAux; 		//Lista de elementos
  TablaHashT ListaRnd; 		//Lista de elementos desordenada al azar
  TablaHashT TablaHash;		//Tabla Hash
  unsigned int TamTabla = 799;	//Tamao de la tabla

  DataArrT AIntentosIns;	//Arreglo con datos de desempeo en insercin
  int PromedioIns;		//Promedio de desempeo de insercin para cada FC
  int PromedioInsT;		//Promedio de desempeo de insercin terico para cada FC
  DataArrT AIntentosBus;	//Arreglo con datos de desempeo en bsqueda
  int PromedioBus;		//Promedio de desempeo de bsqueda para cada FC
  int PromedioBusT;		//Promedio de desempeo de bsqueda terico para cada FC
  float factordecarga;		//Factor de Carga
  int intentos;

 
  if ((argc < 2) || (argc > 3))			//Si hay error en cantidad de parmetros...
     mensaje_de_error();          		//...informar al usuario....
   else                                         //No hay error en la cantidad de parmetros
     {
       i = 1;                                   //Chequear si los parmetros son correctos
       do
        {
          if (((atoi(argv[i])) < 1) || ((atoi(argv[i])) > 2)) 	//Si algn parmetro no es correcto...
           {
             error = 1;                                		//...error!!
             mensaje_de_error();                       		//Informar al usuario.
           }//EndIf
          i++;
        }//EndDoWhile
       while ((i < argc) && (error == 0));		//Revisar todos los parmetros, o hasta encontrar error
       if ((error == 0) && (argc == 3))			//Si hay dos parmetros de la lnea de comandos...
         {
           if (atoi(argv[1]) == atoi(argv[2]))		//..entonces hay que revisar que no sean iguales...
             {
               error = 1;				//Si son iguales... Error!
               mensaje_de_error();			//Informar al usuario...
             }//EndIf
         }//EndIf
       if (error == 0)                           	//El usuario, por fin, aprendi cmo funca esto...
        {
          printf ("Un momento, por favor...\n");
	  ListaAux = CrearTHash (TamTabla);		//Crea TamTabla espacios en una lista auxiliar
   	  ListaRnd = CrearTHash (TamTabla);		//Crea TamTabla espacios en la lista aleatoria       
	  cargarlistaaux (ListaAux, TamTabla);		//Carga la lista de palabras, en orden, del archivo.
          escribir_archivo_gnu (argc-1, argv);		//Genera archivo .gnu para despliegue grfico
	  for (i = 1; i <= (argc-1) ; i++)           	//...ejecutar algoritmos
            {
              tipo_de_hash = atoi(argv[i]);      	//qu algoritmo ejecutaremos?
	      if (tipo_de_hash == 1)			//Ejecutamos hash multiplicativo?
                {
                  DFIns = fopen (F_Ins_Hash_Mult, "w");	//Crear y abrir archivo de datos de insercin
		  DFBus = fopen (F_Sea_Hash_Mult, "w");	//Crear y abrir archivo de datos de bsqueda
		}//EndIf
 	       else					//Ejecutamos hash lineal?
                 {
                  DFIns = fopen (F_Ins_Hash_Lin, "w");	//Crear y abrir archivo de datos de insercin
		  DFBus = fopen (F_Sea_Hash_Lin, "w");	//Crear y abrir archivo de datos de bsqueda
		 }//EndElse
	      for (j = 0; j < 10; j++)		 	//Vamos a ejecutarlo 10 veces, para calcular el promedio
		{
	          crearlistarnd (ListaAux, ListaRnd, TamTabla); //Primero, creamos una lista desordenada al azar
		  TablaHash = CrearTHash (TamTabla);	//Crear la tabla hash
		  for (k = 0; k < TamTabla; k++)	//Para cada elemento de la lista desordenada...
                    {
		      InsertarHash (TablaHash, ListaRnd[k], TamTabla, tipo_de_hash, intentos); //Insertar
		      AIntentosIns[k][j] = intentos;	//Guardar cantidad de intentos de ingreso en arreglo
		      AIntentosBus[k][j] = 0;		//Resetear cant. int. de bsqueda para este factor de carga
		      for (l = 0; l <= k; l++)		//Buscar cada elemento ingresado hasta el momento...
			{
			  BuscarHash (TablaHash, ListaRnd[l], TamTabla, tipo_de_hash, intentos);
			  AIntentosBus[k][j] = AIntentosBus[k][j]+intentos;
			}//EndFor
		      AIntentosBus[k][j] = AIntentosBus[k][j] / (k+1); //...y calcular el promedio de busq. para este F.de carga.
		    }//EndFor
		  DestruirTHash (TablaHash, TamTabla);	//Destruir la tabla hash de esta iteracin.
		}//EndFor  

	      for (j = 1; j < (TamTabla-1); j++)		//Para cada factor de carga...
                {
		  PromedioIns = 0;			//Resetear variable
		  PromedioBus = 0;			//Resetear variable
                  for (k = 0; k < 10; k++)		//Sumar los desempeos...
                    {
                      PromedioIns = PromedioIns + AIntentosIns[j][k];
		      PromedioBus = PromedioBus + AIntentosBus[j][k];
		    }//EndFor
                  PromedioIns = PromedioIns /10;	//...y calcular sus promedios...
	          PromedioBus = PromedioBus /10;
		  factordecarga = (j*1.0) / (TamTabla*1.0);	//Calcular factor de carga
		  PromedioInsT = (int) (1/(1-factordecarga));
		  PromedioBusT = (int) ((1/factordecarga)*log(1/(1-factordecarga))+(1/factordecarga));
		  fprintf (DFIns, "  %10.6f \t %d \t %d \n", factordecarga, PromedioIns, PromedioInsT); //Escribir datos de ins.
  		  fprintf (DFBus, "  %10.6f \t %d \t %d \n", factordecarga, PromedioBus, PromedioBusT); //Escribir datos de bus.
		}//EndFor
              fclose (DFIns);
              fclose (DFBus);           
            }//EndFor
          DestruirTHash (ListaAux, TamTabla);
	  DestruirTHash (ListaRnd, TamTabla);
	 }//EndIf

      printf ("Listo para visualizar los grficos...\n");
      system ("gnuplot graficos.gnu");		//Despliegue de grficos
     }//EndElse
}//EndMain


//*****************************************************************************************************
//Funcion mensaje_de_error
//Si hubo error en los parmetros de la lnea de comandos, se informa al usuario
void mensaje_de_error (void)
{
       printf ("\nError: Parmetos mal ingresados! \n");  	//...informar al usuario....
       printf ("Modo de uso: \n");
       printf ("./diagrama tipo_de_hash1 [tipo_de_hash2]\n");
       printf ("\n");
       printf ("tipo_de_hash = 1  : Para Ver diagrama de Hash Multiplicativo\n");
       printf ("tipo_de_hash = 2  : Para Ver diagrama de Hash Lineal\n");
       printf ("Importante: tipo_de_hash1 != tipo_de_hash2\n\n");
}//End mensaje_de_error
