#include <stdio.h>
#include <stdlib.h>

//Funcin escribir_gnu_inshmult
//Agrega los comandos gnuplot requeridos para mostrar el diagrama de intentos de insercin v/s factor de carga y 
//los comandos gnuplot requeridos para mostrar el diagrama de intentos de bsqueda v/s factor de carga para
//la versin de hashing multiplicativo
//Variable de entrada: descriptor del archivo .gnu
void escribir_gnu_hashmult (FILE *File_GNU)
{
  fprintf (File_GNU,"set title \"Cantidad Promedio de Intentos de Insercin v/s Factor de Carga - Hash Multiplicativo\"\n"); 
  fprintf (File_GNU,"set xlabel \"Factor de Carga\" \n"); 
  fprintf (File_GNU,"set ylabel \"Cantidad Promedio de Intentos de Insercin\" \n"); 
  fprintf (File_GNU,"set xrange [0:1] \n");
  fprintf (File_GNU,"set grid \n\n");
  fprintf (File_GNU,"plot \"INSHMUL.DAT\" using 1:2 title \"Prctico\" with points 1, ");
  fprintf (File_GNU,"\"INSHMUL.DAT\" using 1:3 title \"Terico\" with points 2\n");
  fprintf (File_GNU,"pause 5 \n\n");
  fprintf (File_GNU,"set title \"Cantidad Promedio de Intentos de Bsqueda Exitosa v/s Factor de Carga - Hash Multiplicativo\"\n"); 
  fprintf (File_GNU,"set xlabel \"Factor de Carga\" \n"); 
  fprintf (File_GNU,"set ylabel \"Cantidad Promedio de Intentos de Bsqueda\" \n"); 
  fprintf (File_GNU,"set xrange [0:1] \n");
  fprintf (File_GNU,"set yrange [0:50] \n");
  fprintf (File_GNU,"set grid \n\n");
  fprintf (File_GNU,"plot \"SEAHMUL.DAT\" using 1:2 title \"Prctico\" with points 1, ");
  fprintf (File_GNU,"\"SEAHMUL.DAT\" using 1:3 title \"Terico\" with points 2\n");
  fprintf (File_GNU,"pause 5 \n\n");
}//Endescribir_gnu_hashmult


//Funcin escribir_gnu_inshlin
//Agrega los comandos gnuplot requeridos para mostrar el diagrama de intentos de insercin v/s factor de carga y
//los comandos gnuplot requeridos para mostrar el diagrama de intentos de bsqueda v/s factor de carga para
//la versin de hashing lineal
//Variable de entrada: descriptor del archivo .gnu
void escribir_gnu_hashlin (FILE *File_GNU)
{
  fprintf (File_GNU,"set title \"Cantidad Promedio de Intentos de Insercin v/s Factor de Carga - Hash Lineal\"\n"); 
  fprintf (File_GNU,"set xlabel \"Factor de Carga\" \n"); 
  fprintf (File_GNU,"set ylabel \"Cantidad Promedio de Intentos de Insercin\" \n"); 
  fprintf (File_GNU,"set xrange [0:1] \n");
  fprintf (File_GNU,"set grid \n\n");
  fprintf (File_GNU,"plot \"INSHLIN.DAT\" using 1:2 title \"Intentos\" with points 1, ");
  fprintf (File_GNU,"\"INSHLIN.DAT\" using 1:3 title \"Terico\" with points 2\n");
  fprintf (File_GNU,"pause 5 \n\n");
  fprintf (File_GNU,"set title \"Cantidad Promedio de Intentos de Bsqueda Exitosa v/s Factor de Carga - Hash Lineal\"\n"); 
  fprintf (File_GNU,"set xlabel \"Factor de Carga\" \n"); 
  fprintf (File_GNU,"set ylabel \"Cantidad Promedio de Intentos de Bsqueda\" \n"); 
  fprintf (File_GNU,"set xrange [0:1] \n");
  fprintf (File_GNU,"set yrange [0:50] \n");
  fprintf (File_GNU,"set grid \n\n");
  fprintf (File_GNU,"plot \"SEAHLIN.DAT\" using 1:2 title \"Intentos\" with points 1, ");
  fprintf (File_GNU,"\"SEAHLIN.DAT\" using 1:3 title \"Terico\" with points 2\n");
  fprintf (File_GNU,"pause 5 \n\n");
}//Endescribir_gnu_hashlin

//Funcin escribir_archivo_gnu
//Escribe un archivo .gnu para ser ejecutado por gnuplot
//Lo que se escriba depende de qu algoritmos se ejecuten
//Variables de entrada: cantidad_argumentos - cantidad de args. en la linea de comando
//			argumentos          - argumentos de la linea de comando
void escribir_archivo_gnu (int cantidad_argumentos, char *argumentos[])
{
   FILE *File_GNU;	//Descriptor de archivo
   int  i;		//Contador

   File_GNU = fopen ("graficos.gnu", "w");	//Crea y abre el archivo .gnu

   //Las lneas siguientes son las lneas fijas del archivo .gnu	
   fprintf (File_GNU,"set title \"Comparacin de desempeo de algoritmos de Hashing\" \n");
   fprintf (File_GNU,"set xlabel \"Factor de Carga de la Tabla Hash\" \n");
   fprintf (File_GNU,"set ylabel \"Promedio de Intentos\" \n");
   fprintf (File_GNU,"set xrange [0:1] \n");
   fprintf (File_GNU,"set grid \n");
   fprintf (File_GNU,"\n");

   for (i = 1; i <= cantidad_argumentos; i++)	//Para cada argumento de la lnea de comandos...
     {
       if (atoi(argumentos[i]) == 1)		//...se ejecut hash multiplicativo?...
         {
           escribir_gnu_hashmult(File_GNU);	//..entonces, escribir su cdigo para GNUPLOT
         }//EndIf
        else					//...se ejecut hash lineal?...
          {
            escribir_gnu_hashlin(File_GNU);	//..entonces, escribir su cdigo para GNUPLOT
          }//EndElse
     }//EndFor

   fprintf (File_GNU, "pause -1 \n");		//Agrega una pausa en el despliegue del grfico
   fclose (File_GNU);
}//End escribir_archivo_gnu
