#include <string.h>
#include <sys/timeb.h>
#include "variables.h"

//Funcin cargarlistaaux : Carga los elementos del archivo words.txt en orden
//Variables de entrada   : Arreglo de claves vaco.
//Variables de salida	 : Arreglo de claves cargado.
void cargarlistaaux (TablaHashT ListaAux, unsigned int Tam)
{  
  FILE *WordsFile; 		//Descriptor del archivo con palabras.
  char buffer[50];		//Buffer
  int i = 0; 			//Contador inicializado a 0
  unsigned long int clave;	//Clave para la palabra

  WordsFile = fopen ("words.txt", "r");			//Abrir archivo de palabras slo lectura
  while ((fgets(buffer,sizeof(buffer),WordsFile) > 0) && (i < Tam))	//Mientras no llegamos al fin del archivo....
    {
      ListaAux[i].Palabra = new char[strlen(buffer)];	//Crear espacio para el elemento
      strcpy (ListaAux[i].Palabra, buffer);		//Guardar el elemento ledo del archivo en el arreglo
      i++;						//Incrementar contador
    }//EndWhile
  fclose (WordsFile);					//Cerrar el archivo.
}//End cargarlistaaux


//Funcin crearlistarnd : Crea una lista desordenada al azar con los elementos del archivo.
//Variables de entrada  : Arreglo de claves ordenado segn orden original del archivo words.txt.
//Variables de salida	: Arreglo de claves desordenado aleatoriamente.
void crearlistarnd (TablaHashT ListaAux, TablaHashT ListaRnd, int N)
{  
  struct timeb semilla;		//Semilla aleatoria
  int indice,			//Indice escogido al azar.
      insertado,		//Sentinela. 
      i;			//Contador.

  ftime (&semilla);	       	//Crear semilla a partir del reloj
  srandom (semilla.millitm);   	// Plantar la semilla

  for (i = 0; i < N; i++)		//Inicializar arreglo aleatorio...
      ListaRnd[i].Palabra = NULL; 	//...con valores NULL

//A continuacin, se randomiza el arreglo ListaRnd hasta un punto en que se asegure que la ejecucin de
//dicha randomizacin sea rpida.

  for (i = 0; i < N-10; i++)	//Para cada elemento...
   {
     insertado = 0;		//El elemento actual no est insertado en el arreglo aleatorio.
     do
      {  
	indice = 1+(int)((1.0*N*random())/(RAND_MAX+1.0)); 	//...Calcular una posicin aleatoriamente...
        if (ListaRnd[indice].Palabra == NULL)		     	//Si la posicin calculada no est en uso...
	 {
	   ListaRnd[indice].Palabra = new char[strlen(ListaAux[i].Palabra)]; //...crear espacio para el elemento...
           strcpy (ListaRnd[indice].Palabra, ListaAux[i].Palabra); 	     //...y agregar elemento a lista aleatoria.
	   insertado = 1;			       			     //Podemos pasar al siguiente elemento
	 }//EndIf
      }//EndDoWhile
     while (insertado == 0);			//Repetir para cada elemento hasta encontrar un lugar libre.
   }//EndFor

  indice = 0;					//Volver al principio del arreglo aleatorio.

//Ahora, se termina de llenar el arreglo randomizado con los elementos que faltan del arreglo original insertados
//en las posiciones libres del arreglo randomizado

  for (i = N-10; i < N; i++)			//Para los elementos de ListaAux que restan...
   {   
     while (ListaRnd[indice].Palabra != NULL)	//...buscarles el primer espacio libre en ListaRnd..
      {
	indice++;
      }//EndWhile
     ListaRnd[indice].Palabra = new char[strlen(ListaAux[i].Palabra)];  //...crear espacio para el elemento...
     strcpy (ListaRnd[indice].Palabra, ListaAux[i].Palabra);		//...e insertarlo...
   }//EndFor
}//Endcrearlistarnd
